using System;

namespace SlatedGameToolkit.Framework.Graphics.OpenGL
{
    internal delegate void GLClearColour(float r, float g, float b);
    internal delegate void GLClear(GLEnums flags);
    internal delegate void GLViewport(int x, int y, int width, int height);
    internal delegate UIntPtr GLCreateShader(GLEnums type);
    internal delegate UIntPtr GLShaderSource(UIntPtr shaderHandle, uint count, string program, int[] length);
    internal delegate void GLCompileShader(UIntPtr shaderHandle);
    internal delegate void GLGetShaderLogInfo(UIntPtr shader, uint maxLength, out uint writtenLength, out string output);
    internal delegate UIntPtr GLCreateProgram();
    internal delegate UIntPtr GLDeleteProgram(UIntPtr program);
    internal delegate void GLAttachShader(UIntPtr program, UIntPtr shader);
    internal delegate void GLDetachShader(UIntPtr program, UIntPtr shader);
    internal delegate void GLDeleteShader(UIntPtr shader);
    internal delegate void GLBindAttribLocation(UIntPtr program, uint index, string name);
    internal delegate void GLGetProgramInfoLog(UIntPtr program, uint maxLength, out uint writtenLength, out string output);
    internal delegate void GLLinkProgram(UIntPtr program);
    internal delegate void GLProgramParameter(UIntPtr program, GLEnums parameterName, int value);
    internal delegate void GLUseProgram(UIntPtr program);
    internal delegate void GLGenProgramPipelines(uint size, out UIntPtr[] pipelines);
    internal delegate void GLDeleteProgramPipelines(uint size, UIntPtr[] pipelines);
    internal delegate void GLBindProgramPipeline(UIntPtr pipeline);
    internal delegate void GLUseProgramStages(UIntPtr pipeline, GLEnums bitField, UIntPtr program);
    internal delegate uint GLGetError();
}