using System;
using System.Runtime.InteropServices;
using SDL2;
using SlatedGameToolkit.Framework.Exceptions;
using SlatedGameToolkit.Framework.Graphics.Window;

namespace SlatedGameToolkit.Framework.Graphics.OpenGL.Shaders
{
    public class GLVertexShader : GLShader {
        public GLVertexShader(string shader) : base() {
            Handle = createShader(GLEnums.GL_VERTEX_SHADER);
            shaderSource(Handle, 1, shader, null);
            compileShader(Handle);
            uint logLength;
            string shaderLog;
            getShaderLogInfo(Handle, 1024, out logLength, out shaderLog);
            if (logLength > 0) {
                Dispose();
                throw new OpenGLException(shaderLog);
            }
        }

        public override void Dispose()
        {
            deleteShader(Handle);
        }

        ~GLVertexShader() {
            Dispose();
        }
    }
}