using System.Collections.Generic;
using SDL2;

namespace SlatedGameToolkit.Framework.Graphics.Window
{
    internal static class WindowContextsManager {
        private static Dictionary<uint, WindowContext> existingWindows = new Dictionary<uint, WindowContext>();

        internal static void RegisterWindow(WindowContext windowHandle) {
            GameEngine.Logger.Debug("Registering window: " + windowHandle.WindowID);
            existingWindows.Add(windowHandle.WindowID, windowHandle);
        }
        
        internal static void DeregisterWindow(WindowContext windowHandle) {
            GameEngine.Logger.Debug("Deregistering window: " + windowHandle.WindowID);
            existingWindows.Remove(windowHandle.WindowID);
        }

        public static WindowContext ContextFromWindowID(uint ID) {
            return existingWindows[ID];
        }

        public static WindowContext CurrentWindowContext() {
            return ContextFromWindowID(SDL.SDL_GetWindowID(SDL.SDL_GL_GetCurrentWindow()));
        }
    }
}